#include "error.h"

using namespace std;



double sqr(double x);
double cube(double x);
double cubert(double x);
long long int gif(double x);
double sqrt(double x);
double mod(double x);
double fact(double x);
long long int npr(long int n,long int r);
long long int ncr(long int n,long int r);
double ipow(double a,int b);
double inv(double x);
double roundangle(double angle);
double sin(double x);
double cos(double x);
double tan(double x);
double cosec(double x);
double sec(double x);
double cot(double x);
int numdigit(double x);
double roundoff(double x,int n);
long long int reversenumber(long long int n);
double ln(double x);
double log10(double x);
double log(double base,double x);
double exp(double x);
double pow10(double x);
double fpow(double a,double b);
double pow(double a,double b);
double asin(double x);
double acos(double x);
double atan(double x);

//function to give square of any number
double sqr(double x)
{
    return x*x;
}


//function to return cube of any number
double cube(double x)
{
    return x*x*x;
}



//functions for greatest integer
long long int gif(double x)
{
    if(x>=0)
    {
    return x/1;
    }
    else
    {
        if(mod(x)==gif(mod(x)))
           {
               return x/1;
           }
            else
            {
        return x/1-1;
            }
    }
}



//function to calculate non negative square root of a non negative number
double sqrt(double x)
{
double i;
if(x>=0)
   {
for(i=0;i*i<x;i=i+0.000001)
    {
    }
return i;
}
else
{

}
}



//function to calculate cuberoot of a real number positive or negative
double cubert(double x)
{
double i;
if(x>=0)
    {
for(i=0;i*i*i<x;i=i+0.000001)
{
}
return i;
}
else
{
for(i=0;i*i*i>x;i=i+0.000001)
{
}
return i;
}
}



//function to calculate absolute value of a number
double mod(double x)
{
if(x>=0)
    {
        return x;
}
else
    {
        return -x;
}
}

int sign(double x)
{
if(x>0){return 1;}
else if(x<0){return -1;}
else{return 0;}
}

//functions for factorial
double factorial(double x)
{
if(x==gif(x) && x>=0)
{
if(x==0){return 1;}
else {return x*factorial(x-1);}
}
else {return -1;}
}

//function to calculate combinatrix of n and r
long long int ncr(long int n,long int r)
{
    if(n<r){return -1;}
else {return factorial(n)/(factorial(r)*factorial(n-r));}
}



//function to calculate permutation of n and r
long long int npr(long int n,long int r)
{
    if(n<r){return -1;}
else {return factorial(n)/factorial(n-r);}
}



//function for getting integral power of any number
double ipow(double a,int b)
{
    double ipow=1;
    int i;
    if(b==0){return 1;}
    else
    {
    for(i=1;i<=mod(b);i++)
    {
        ipow=ipow*a;
    }
    if(b>0)
    {
    return ipow;
    }
    else
    {
        return 1/ipow;
    }
    }
}




//function for getting inverse of a number
double inv(double x)
{
    if(x==0)
    {

    }
    return 1/x;
}



//functions for reducing any angle in between 0 to 360 degree
double roundangle(double angle)
{
    if(angle>=0 && angle<360)
    {
        return angle;
    }
    else if(angle>=360)
    {

        for(;angle>=360;)
        {
            angle=angle-360;
        }
        return angle;
    }

     else if(angle<0)
    {

        for(;angle<0;)
        {
            angle=angle+360;
        }
        return angle;
    }

}


//functions for sine of an angle given in degrees
double sin(double x)
{
    double angle=roundangle(x);
    const double pi=3.141592654;
    const double sin0=0;
    const double sin30=0.5;
    const double sin45=0.7071067821;
    const double sin60=0.8660254038;
    const double sin90=1;

        if(angle<=90)
    {
    if(angle==0){return sin0;}
    else if(angle==30){return sin30;}
    else if(angle==45){return sin45;}
    else if(angle==60){return sin60;}
    else if(angle==90){return sin90;}
    else
    {
        double sum=0;int i;
        for(i=1;i<30;i++)
        {
            sum=sum+((ipow(pi*x/180,2*i-1)*ipow(-1,i+1))/factorial(2*i-1));
        }
        return sum;
    }
    }

    else if(angle>90 && angle<=180)
    {
        return sin(180-angle);
    }

    else if(angle>180 && angle<=270)
    {
        return 0-sin(angle-180);
    }

    else if(angle>270)
    {
        return 0-sin(360-angle);
    }
}



//functions for getting cosine of an angle given in degrees
double cos(double x)
{
    return sin(90-x);
}



//function for calculating tangent of a number
double tan(double x)

{
    if(cos(x)==0)
    {

    }
        return sin(x)/cos(x);
}



//functions for calculating cosecant of an angle given in degrees{
    double cosec(double x)
    {
        if(sin(x)==0)
        {

        }
        return 1/sin(x);
    }


//functions for calculating secant of an angle given in degrees
double sec(double x)
{
    if(cos(x)==0)
    {

    }
    return 1/cos(x);
}



//functions for calculating cotangent of an angle given in degrees
double cot(double x)
{
    if(tan(x)==0)
    {

    }
    return 0+1/tan(x);
}



//function to count number of digit in integral part of a number
int numdigit(double x)
{
    long long int number=gif(x);
    int i=0;
    for(i=1;number!=0;i++)
    {
        number=number/10;
    }
    return i-1;
}



//function to round off a number up to n digit after decimals
//if n is entered as zero it round off to an integer
double roundoff(double x,int n)
{
    if(((gif(mod(x)*ipow(10,n+1))%10)>5)||(((gif(mod(x)*ipow(10,n+1))%10)==5)&&(((gif(mod(x)*ipow(10,n))%10)%2)!=0)))
    {
        if(x>=0)
        {
        return gif(mod(x)*ipow(10,n)+1)/ipow(10,n);
        }
        else
        {
            return 0-gif(mod(x)*ipow(10,n)+1)/ipow(10,n);
        }
    }
    else if(((gif(mod(x)*ipow(10,n+1))%10)<5)||(((gif(mod(x)*ipow(10,n+1))%10)==5)&&(((gif(mod(x)*ipow(10,n))%10)%2)==0)))
    {
        if(x>=0)
        {
        return gif(mod(x)*ipow(10,n))/ipow(10,n);
        }
        else
        {
        return 0-gif(mod(x)*ipow(10,n))/ipow(10,n);
        }
    }
}




//functions to find reverse of integral part of the number
long long int reversenumber(long long int n)
{
long long int reverseofnumber=0,j;
j=n;
if(n=0)
{
   return 0;
}
else if(n<0)
{
    return -1;
}
else
{
while(j>0)
{
reverseofnumber=reverseofnumber*10+j%10;
j=j/10;
}
}
return reverseofnumber;
}





//functions for natural logarithm
double ln(double x)
{
    const double ln10=2.302585093;
    if(x<=0)
    {

    }
    else if(x>0)
    {
        if(x==1)
        {
            return 0;
        }
        else
        {
        double sum=0;int k;
        double n=(1-(x/ipow(10,numdigit(x))));
        for(k=1;k<1000;k++)
        {
            sum=sum-ipow(n,k)/k;
        }

        return numdigit(x)*ln10+sum;
        }
    }
    else
    {
        return 0;
    }
}



//function to calculate log to base 10
double log10(double x)
{
    const double ln10=2.302585093;
        return ln(x)/ln10;
}




//functions to calculate log of a to base b
double log(double base,double x)
{
    if(base<=0 || base==1 || x<=0)
    {

    }
    else
    {
    return ln(x)/ln(base);
    }
}




//e raised to x
double exp(double x)
{
    const double e=2.718281828;
    double sum1=1,sum2=1;int i,j;
    for(i=1;i<=gif(mod(x));i++)
    {
        sum1=sum1*e;
    }
    for(j=1;j<50;j++)
    {
        sum2=sum2+ipow(mod(x)-gif(mod(x)),j)/factorial(j);
    }
    if(x>=0)
    {
    return sum1*sum2;
    }
    else
    {
        return 1/(sum1*sum2);
    }
}



//10 raised to x
double pow10(double x)
{
    const double ln10=2.302585093;
    return exp(x*ln10);
}


//function to calculate a^b where b lies in (0,1)
double fpow(double a,double b)
{
    double sum=1;int i;
    for(i=1;i<50;i++)
    {
        sum=sum+ipow(b*ln(a),i)/factorial(i);
    }
    return sum;
}



//functions to calculate a^b in general
double pow(double a,double b)
{




            if(a<=0)
            {
                return 0;
            }
            else
            {
             return ipow(a,gif(b))*fpow(a,b-gif(b));
            }

}




//inverse tangent function
double atan(double x)
{
    const double atan0=0;
    const double atan1=45;
    const double pi=3.141592654;
    if(x>=0)
        {
            double sum=0;
            if(x==0)
            {
            return atan0;
            }
            else if(x==1)
            {
            return atan1;
            }
            else if(x>0 && x<1)
            {   int i;
                for(i=1;i<1000;i++)
                {
                sum=sum+ipow(x,2*i-1)*ipow(-1,i+1)/(2*i-1);
                }
                return sum*180/pi;
            }
            else
            {   int i;
                for(i=1;i<1000;i++)
                {
                sum=sum+ipow(1/x,2*i-1)*ipow(-1,i+1)/(2*i-1);
                }
                return 90-sum*180/pi;
            }
        }
    else
        {
            return 0-atan(mod(x));
        }
    }



//inverse sine functions
double asin(double x)
{
    if(x<-1 || x>1)
    {

    }
    else
    {
        if(x>=0)
        {
            if(x==1)
            {
            return 90;
            }
            else
            {
            return atan(x/sqrt(1-sqr(x)));
            }
        }
        else
        {
            if(x==-1)
            {
            return -90;
            }
            else
            {
            return 0-atan(mod(x)/sqrt(1-sqr(x)));
            }
        }
    }
}



//inverse cosine function
double acos(double x)
{
if(x<-1 || x>1)
{

}
else
{
if(x>=0)
{
return 90-asin(x);
}
else
{
return 90-asin(x);
}
}
}
